net.sf.saxon.expr.instruct

## Class ParentNodeConstructor

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction
    - - net.sf.saxon.expr.instruct.ParentNodeConstructor

- All Implemented Interfaces:
    DivisibleInstruction, Serializable, SourceLocator, LocationProvider, SaxonLocator, TailCallReturner, ValidatingInstruction, InstructionInfo, Locator
  Direct Known Subclasses:
    DocumentInstr, ElementCreator

      public abstract class ParentNodeConstructor
      extends Instruction
      implements ValidatingInstruction, DivisibleInstruction

  An abstract class to act as a common parent for instructions that create element nodes and document nodes.
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Expression` | `content`
    `protected boolean` | `preservingTypes` Flag set to true if validation=preserve and no schema type supplied for validation; also true when validation="strip" if there is no need to physically strip type annotations

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, INHERITED_CONTEXT, INSPECTION_CONTEXT, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, NAVIGATION_CONTEXT, NODE_VALUE_CONTEXT, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, W3C_CONSUMING, W3C_FREE_RANGING, W3C_GROUP_CONSUMING, W3C_MOTIONLESS, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ParentNodeConstructor()` Create a document or element node constructor instruction

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `PathMap.PathMapNodeSet` | `addToPathMap(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` Add a representation of this expression to a PathMap.
    `protected abstract void` | `checkContentSequence(StaticContext env)` Check that the child instructions don't violate any obvious constraints for this kind of node
    `int` | `computeCardinality()` Get the cardinality of the sequence returned by evaluating this instruction
    `boolean` | `createsNewNodes()` Determine whether this instruction creates new nodes.
    `String` | `getBaseURI()` Get the static base URI of the instruction
    `int` | `getCardinality()` Determine the static cardinality of the expression.
    `Expression` | `getContentExpression()` Get the expression that constructs the content of the element
    `SchemaType` | `getSchemaType()` Get the schema type chosen for validation; null if not defined
    `int` | `getValidationAction()` Get the validation mode for this instruction
    `ParseOptions` | `getValidationOptions()` Get the validation options
    `boolean` | `isLazyConstruction()` Establish whether lazy construction is to be used
    `boolean` | `isPreservingTypes()` Determine whether this elementCreator performs validation or strips type annotations
    `Iterator<SubExpressionInfo>` | `iterateSubExpressionInfo()` Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression.
    `Iterator<Expression>` | `iterateSubExpressions()` Get the immediate sub-expressions of this expression.
    `Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
    `protected void` | `promoteInst(PromotionOffer offer)` Handle promotion offers, that is, non-local tree rewrites.
    `boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
    `void` | `setBaseURI(String uri)` Set the static base URI of the instruction
    `void` | `setContentExpression(Expression content)` Set the expression that constructs the content of the element
    `void` | `setLazyConstruction(boolean lazy)` Indicate that lazy construction should (or should not) be used.
    `void` | `setNoNeedToStrip()` Set that the newly constructed node and everything underneath it will automatically be untyped, without any need to physically remove type annotations, even though validation=STRIP is set.
    `void` | `setValidationAction(int mode, SchemaType schemaType)` Set the validation mode for the new document or element node
    `Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression.
    `Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform type checking of an expression and its subexpressions.

    - ### Methods inherited from class net.sf.saxon.expr.instruct.Instruction

      `assembleParams, assembleTunnelParams, computeSpecialProperties, dynamicError, evaluateAsString, evaluateItem, getConstructType, getExpressionName, getImplementationMethod, getInstructionName, getInstructionNameCode, getItemType, getIteratorFromProcessMethod, getSourceLocator, isXSLT, iterate, process, processLeavingTail, promote`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, copy, doPromotion, dynamicError, effectiveBooleanValue, evaluatePendingUpdates, explain, explain, getColumnNumber, getColumnNumber, getContainer, getDependencies, getEvaluationMethod, getExecutable, getExpressionCompiler, getHostLanguage, getIntegerBounds, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getStreamability, getStreamingAdjunct, getSystemId, getSystemId, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateEvents, markTailFunctionCalls, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, toPattern, toStreamingPattern, toString, typeError`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface javax.xml.transform.SourceLocator

      `getColumnNumber, getLineNumber, getPublicId, getSystemId`

    - ### Methods inherited from interface com.saxonica.stream.adjunct.DivisibleInstruction

      `processLeft, processRight`

- - ### Field Detail

    - #### content

          protected Expression content

    - #### preservingTypes

          protected boolean preservingTypes

      Flag set to true if validation=preserve and no schema type supplied for validation; also true when validation="strip" if there is no need to physically strip type annotations

  - ### Constructor Detail

    - #### ParentNodeConstructor

          public ParentNodeConstructor()

      Create a document or element node constructor instruction

  - ### Method Detail

    - #### setBaseURI

          public void setBaseURI(String uri)

      Set the static base URI of the instruction
      Parameters:
        `uri` - the static base URI

    - #### getBaseURI

          public String getBaseURI()

      Get the static base URI of the instruction
      Returns:
        the static base URI

    - #### setLazyConstruction

          public void setLazyConstruction(boolean lazy)

      Indicate that lazy construction should (or should not) be used. Note that this request will be ignored if validation is required
      Parameters:
        `lazy` - set to true if lazy construction should be used

    - #### isLazyConstruction

          public final boolean isLazyConstruction()

      Establish whether lazy construction is to be used
      Returns:
        true if lazy construction is to be used

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the schema type chosen for validation; null if not defined
      Specified by:
        `getSchemaType` in interface `ValidatingInstruction`
      Returns:
        the type to be used for validation. (For a document constructor, this is the required type of the document element)

    - #### getValidationOptions

          public ParseOptions getValidationOptions()

      Get the validation options
      Returns:
        the validation options for the content of the constructed node. May be null if no validation was requested.

    - #### setValidationAction

          public void setValidationAction(int mode,
                                 SchemaType schemaType)

      Set the validation mode for the new document or element node
      Parameters:
        `mode` - the validation mode, for example `Validation.STRICT`
        `schemaType` - the required type (for validation by type). Null if not validating by type

    - #### getValidationAction

          public int getValidationAction()

      Get the validation mode for this instruction
      Specified by:
        `getValidationAction` in interface `ValidatingInstruction`
      Returns:
        the validation mode, for example `Validation.STRICT` or `Validation.PRESERVE`

    - #### setNoNeedToStrip

          public void setNoNeedToStrip()

      Set that the newly constructed node and everything underneath it will automatically be untyped, without any need to physically remove type annotations, even though validation=STRIP is set.

    - #### setContentExpression

          public void setContentExpression(Expression content)

      Set the expression that constructs the content of the element
      Parameters:
        `content` - the content expression

    - #### getContentExpression

          public Expression getContentExpression()

      Get the expression that constructs the content of the element
      Specified by:
        `getContentExpression` in interface `DivisibleInstruction`
      Returns:
        the content expression

    - #### computeCardinality

          public int computeCardinality()

      Get the cardinality of the sequence returned by evaluating this instruction
      Overrides:
        `computeCardinality` in class `Instruction`
      Returns:
        the static cardinality

    - #### simplify

          public Expression simplify(ExpressionVisitor visitor)
                              throws XPathException

      Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.
      Specified by:
        `simplify` in class `Instruction`
      Parameters:
        `visitor` - an expression visitor
      Returns:
        the simplified expression
      Throws:
        `XPathException` - if an error is discovered during expression rewriting

    - #### typeCheck

          public Expression typeCheck(ExpressionVisitor visitor,
                             ExpressionVisitor.ContextItemType contextItemType)
                               throws XPathException

      Description copied from class: `Expression`
      Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

      This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

      If the implementation returns a value other than "this", then it is required to ensure that the location information in the returned expression have been set up correctly. It should not rely on the caller to do this, although for historical reasons many callers do so.

      Overrides:
        `typeCheck` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### checkContentSequence

          protected abstract void checkContentSequence(StaticContext env)
                                                throws XPathException

      Check that the child instructions don't violate any obvious constraints for this kind of node
      Parameters:
        `env` - the static context
      Throws:
        `XPathException` - if the check fails

    - #### optimize

          public Expression optimize(ExpressionVisitor visitor,
                            ExpressionVisitor.ContextItemType contextItemType)
                              throws XPathException

      Description copied from class: `Expression`
      Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### promoteInst

          protected void promoteInst(PromotionOffer offer)
                              throws XPathException

      Handle promotion offers, that is, non-local tree rewrites.
      Overrides:
        `promoteInst` in class `Instruction`
      Parameters:
        `offer` - The type of rewrite being offered
      Throws:
        `XPathException`

    - #### iterateSubExpressions

          public Iterator<Expression> iterateSubExpressions()

      Get the immediate sub-expressions of this expression.
      Overrides:
        `iterateSubExpressions` in class `Expression`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### iterateSubExpressionInfo

          public Iterator<SubExpressionInfo> iterateSubExpressionInfo()

      Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression. Default implementation returns a zero-length array, appropriate for an expression that has no sub-expressions.
      Overrides:
        `iterateSubExpressionInfo` in class `Expression`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### replaceSubExpression

          public boolean replaceSubExpression(Expression original,
                                     Expression replacement)

      Replace one subexpression by a replacement subexpression
      Overrides:
        `replaceSubExpression` in class `Expression`
      Parameters:
        `original` - the original subexpression
        `replacement` - the replacement subexpression
      Returns:
        true if the original subexpression is found

    - #### createsNewNodes

          public final boolean createsNewNodes()

      Determine whether this instruction creates new nodes. This implementation returns true.
      Overrides:
        `createsNewNodes` in class `Instruction`
      Returns:
        true if the instruction creates new nodes (or if it can't be proved that it doesn't)

    - #### getCardinality

          public int getCardinality()

      Description copied from class: `Expression`
      Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.
      Overrides:
        `getCardinality` in class `Expression`
      Returns:
        one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

    - #### addToPathMap

          public PathMap.PathMapNodeSet addToPathMap(PathMap pathMap,
                                            PathMap.PathMapNodeSet pathMapNodeSet)

      Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.

      The default implementation of this method assumes that an expression does no navigation other than the navigation done by evaluating its subexpressions, and that the subexpressions are evaluated in the same context as the containing expression. The method must be overridden for any expression where these assumptions do not hold. For example, implementations exist for AxisExpression, ParentExpression, and RootExpression (because they perform navigation), and for the doc(), document(), and collection() functions because they create a new navigation root. Implementations also exist for PathExpression and FilterExpression because they have subexpressions that are evaluated in a different context from the calling expression.

      Overrides:
        `addToPathMap` in class `Expression`
      Parameters:
        `pathMap` - the PathMap to which the expression should be added
        `pathMapNodeSet` - the PathMapNodeSet to which the paths embodied in this expression should be added
      Returns:
        the pathMapNodeSet representing the points in the source document that are both reachable by this expression, and that represent possible results of this expression. For an expression that does navigation, it represents the end of the arc in the path map that describes the navigation route. For other expressions, it is the same as the input pathMapNode.

    - #### isPreservingTypes

          public boolean isPreservingTypes()

      Determine whether this elementCreator performs validation or strips type annotations
      Returns:
        false if the instruction performs validation of the constructed output or if it strips type annotations, otherwise true

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.